/**************************************
*                                     *
*       Jeff Molofee: Lesson 01       *
*       http://nehe.gamedev.net       *
*                                     *
*         Sphre GLU et Cube          *
*                                     *
*     Recompil par Bob Nol 2019     *
*         Visual Studio 2017          *
**************************************/

#include <windows.h>											// Fichier d'en-tte pour Windows
#include <gl\gl.h>												// Fichier d'en-tte pour la bibliothque OpenGL32
#include <gl\glu.h>												// Fichier d'en-tte pour la bibliothque GLu32
#include "NeHeGL.h"												// Fichier d'en-tte pour NeHeGL

#include <math.h>												// Pour sin et cos, etc.

#pragma comment( lib, "opengl32.lib" )							// Rechercher OpenGL32.lib lors de la liaison
#pragma comment( lib, "glu32.lib" )								// Recherchez GLu32.lib lors de la liaison


#ifndef CDS_FULLSCREEN											// CDS_FULLSCREEN n'est pas dfini par certains
#define CDS_FULLSCREEN 4										// compilateurs. En le dfinissant de cette faon,
#endif															// nous pouvons viter les erreurs

GL_Window*	g_window;
Keys*		g_keys;

// Variables dfinies par l'utilisateur
GLfloat	xrot;													// Rotation X
GLfloat	yrot;													// Rotation Y
GLfloat	zrot;													// Rotation Z


BOOL Initialize (GL_Window* window, Keys* keys)					// Tout code d'initialisation GL et initialisation de 
																// l'utilisateur vont ici
{
	g_window	= window;
	g_keys		= keys;

	// Dbut de l'initialisation de l'utilisateur
	glClearColor (0.0f, 0.0f, 0.0f, 0.5f);						// Fond noir
	glClearDepth (1.0f);										// Configuration du tampon de profondeur
	glDepthFunc (GL_LEQUAL);									// Le type de test de profondeur (infrieur ou gal)
	glEnable (GL_DEPTH_TEST);									// Activer le test de profondeur
	glShadeModel (GL_SMOOTH);									// Slectionnez Smooth Shading
	glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);			// Dfinir les calculs de perspective les plus prcis

	return TRUE;												// Renvoie TRUE (initialisation russie)
}

void Deinitialize (void)										// Tout DeInitialization de utilisateur va ici
{
}

void Update (DWORD milliseconds)								// Effectuer des mises  jour de mouvement ici
{
	if (g_keys->keyDown [VK_ESCAPE])							// Est-ce que chap est press?
		TerminateApplication (g_window);						// Terminer le programme

	if (g_keys->keyDown [VK_F1])								// Est ce que F1 a t presse?
		ToggleFullscreen (g_window);							// Basculer en mode plein cran
}

void Draw (void)
{
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// fface l'affichage et le tampon de profondeur
	
	
	//********************************************************************************************************************************
	// ...Le code de rendu va ici...

	// Code pour une sphre:
	glLoadIdentity();											// Rinitialiser la matrice Modelview

		glTranslatef(0.0f, 0.0f, -5.0f);						// Dplacez x et y de 0.0 units et -5.0 units dans l'cran
		glColor3f(1.0f, 1.0f, 0.0f);							// Couleur Jaune pour la Sphre
		GLUquadricObj *quadric = NULL;
		quadric = gluNewQuadric();
		gluQuadricDrawStyle(quadric, GLU_FILL);					// Polygones remplis

		gluQuadricNormals(quadric, GLU_SMOOTH);					// Mlange lisse et normal (style Gouraud)

		gluQuadricOrientation(quadric, GLU_OUTSIDE);			// Normales vers l'extrieur 

		gluSphere(quadric, 1.3, 50, 50);						// Sphre GLU
		gluDeleteQuadric(quadric);

	glEnd();													// Termin de dessiner la Sphre
	// Code pour un Cube
	glLoadIdentity();											// Rinitialiser la matrice Modelview
	
		glTranslatef(0.0f, 0.0f, -5.0f);						// Dplacez x et y de 0.0 units et -5.0 units dans l'cran
		glRotatef(45.0, 1.0, 0.0, 0.0);							// Rotation de 45 sur l'axe des X
		glRotatef(45.0, 0.0, 1.0, 0.0);							// Rotation de 45 sur l'axe des Y

		glBegin(GL_QUADS);										// Commencer  dessiner les quadrilatres

		glColor3f(0.0f, 1.0f, 0.0f);							// Couleur:		Vert
		glVertex3f(1.0f, 1.0f, -1.0f);							// Quad Haut:	Point en haut  droite
		glVertex3f(-1.0f, 1.0f, -1.0f);							// Quad Haut:	Point en haut  gauche
		glVertex3f(-1.0f, 1.0f, 1.0f);							// Quad Haut:	Point en bas  gauche
		glVertex3f(1.0f, 1.0f, 1.0f);							// Quad Haut:	Point en bas  droite

		glColor3f(1.0f, 0.5f, 0.0f);							// Couleur:		Orange
		glVertex3f(1.0f, -1.0f, 1.0f);							// Quad Bas:	Point en haut  droite
		glVertex3f(-1.0f, -1.0f, 1.0f);							// Quad Bas:	Point en haut  gauche
		glVertex3f(-1.0f, -1.0f, -1.0f);						// Quad Bas:	Point en bas  gauche
		glVertex3f(1.0f, -1.0f, -1.0f);							// Quad Bas:	Point en bas  droite

		glColor3f(1.0f, 0.0f, 0.0f);							// Couleur:		Rouge
		glVertex3f(1.0f, 1.0f, 1.0f);							// Quad Faade:	Point en haut  droite
		glVertex3f(-1.0f, 1.0f, 1.0f);							// Quad Faade:	Point en haut  gauche
		glVertex3f(-1.0f, -1.0f, 1.0f);							// Quad Faade:	Point en bas  gauche
		glVertex3f(1.0f, -1.0f, 1.0f);							// Quad Faade:	Point en bas  droite

		glColor3f(0.60f, 0.40f, 0.12f);							// Couleur:		Brun
		glVertex3f(1.0f, -1.0f, -1.0f);							// Quad Arrire:Point en haut  droite
		glVertex3f(-1.0f, -1.0f, -1.0f);						// Quad Arrire:Point en haut  gauche
		glVertex3f(-1.0f, 1.0f, -1.0f);							// Quad Arrire:Point en bas  gauche
		glVertex3f(1.0f, 1.0f, -1.0f);							// Quad Arrire:Point en bas  droite

		glColor3f(0.0f, 0.0f, 1.0f);							// Couleur:		Bleu
		glVertex3f(-1.0f, 1.0f, 1.0f);							// Quad Gauche:	Point en haut  droite
		glVertex3f(-1.0f, 1.0f, -1.0f);							// Quad Gauche:	Point en haut  gauche
		glVertex3f(-1.0f, -1.0f, -1.0f);						// Quad Gauche:	Point en bas  gauche
		glVertex3f(-1.0f, -1.0f, 1.0f);							// Quad Gauche:	Point en bas  droite

		glColor3f(1.0f, 0.0f, 1.0f);							// Couleur:		Violet
		glVertex3f(1.0f, 1.0f, -1.0f);							// Quad Droit:	Point en haut  droite
		glVertex3f(1.0f, 1.0f, 1.0f);							// Quad Droit:	Point en haut  gauche
		glVertex3f(1.0f, -1.0f, 1.0f);							// Quad Droit:	Point en bas  gauche
		glVertex3f(1.0f, -1.0f, -1.0f);							// Quad Droit:	Point en bas  droite
		
	glEnd();													// Termin de dessiner les quadrilatres


		// La cube moins la sphre = un cube avec un trou au centre de chaque face

		
	//********************************************************************************************************************************
	glFlush ();													// glFlush du pipeline de rendu GL
}
